#include <gb/drawing.h>
#include <gb/gb.h>
#include <rand.h>
#include <stdio.h>
#include "submenumain.c"
#include "submenutime.c"
#include "submenu_chx.c"
#include "submenu_modusx.c"
#include "submenu_voltdivx.c"


void dsomenu(unsigned* timediv, unsigned* cha_amp, unsigned* chb_amp,
		char* cha_mode, char* chb_mode, int* menuitem, int* menustate, int* nextmenustate, char* ch_amp_werte) {


	switch (joypad(0)){
		case (J_RIGHT):
			*menuitem += 1;
			if (*menustate == 5){
				if (*cha_mode == 'A') {
					*cha_mode = 'D';
					cha_mode[1] = 'C';
					cha_mode[2] = ' ';
				} else if (*cha_mode == 'D') {
					*cha_mode = 'G';
					cha_mode[1] = 'N';
					cha_mode[2] = 'D';
				}
			} else if (*menustate == 7){
				if (*chb_mode == 'A'){ 
					*chb_mode = 'D';
					chb_mode[1] = 'C';
					chb_mode[2] = ' ';
				} else if (*chb_mode == 'D') {
					*chb_mode = 'G';
					chb_mode[1] = 'N';
					chb_mode[2] = 'D';
				}
			}
			break;

		case (J_LEFT):
			*menuitem -= 1;
			if (*menustate == 5){
				if (*cha_mode == 'D') { 
					*cha_mode = 'A';
					cha_mode[1] = 'C';
					cha_mode[2] = ' ';
				} else if (*cha_mode == 'G'){ 
					*cha_mode = 'D';
					cha_mode[1] = 'C';
					cha_mode[2] = ' ';
				}
			} else if (*menustate == 7){
				if (*chb_mode == 'D'){
					*chb_mode = 'A';
					chb_mode[1] = 'C';
					chb_mode[2] = ' ';
				} else if (*chb_mode == 'G') { 
					*chb_mode = 'D';
					chb_mode[1] = 'C';
					chb_mode[2] = ' ';
				}
			}
			break;

		// auswhlen:
		case (J_SELECT):
			*menustate = *nextmenustate; // nextmenustate wird in den einzelnen funktionen gesetzt!
			*menuitem = 1; // menuitem zurcksetzen
			break;

		// zurck zum hauptmen: 
		case (J_START): 
			*menustate = 1;
			*menuitem = 1; // menuitem zurcksetzen
			break;

	}


	// debug: 
	//gotogxy(0, 17); // Buchstabe, Zeile
	//gprintf("A: %c%c%c B: %c%c%c", *cha_mode, cha_mode[1], cha_mode[2], *chb_mode, chb_mode[1], chb_mode[2]);


	// grenzen einhalten:
	if (*menuitem <= 1)
		*menuitem = 1;


	//mainmenu
	if (*menustate == 1){
		if (*menuitem >= 4)
			*menuitem = 1;
		submenumain(timediv, cha_amp, chb_amp, menuitem, nextmenustate,  ch_amp_werte);
	}


	//timemenu
	if (*menustate == 2){
		submenutime(timediv);
	}


	//cha menu
	if (*menustate == 3){
		if (*menuitem >= 2)
			*menuitem = 2;
		submenu_chx(cha_amp, chb_amp, cha_mode, chb_mode, menuitem, nextmenustate, 'A', ch_amp_werte);
	}


	//chb menu
	if (*menustate == 4){
		if (*menuitem >= 2)
			*menuitem = 2;
		submenu_chx(cha_amp, chb_amp, cha_mode, chb_mode, menuitem, nextmenustate, 'B', ch_amp_werte);
	}


	//cha modus menu
	if (*menustate == 5){
		switch (*cha_mode){ 
			case ('A'): 
				*menuitem = 1;
				break;
			case ('D'): 
				*menuitem = 2;
				break;
			case ('G'): 
				*menuitem = 3;
				break;
			default: 
				*menuitem = 0;
				break;
		}
		set_mikro(*cha_amp, cha_mode, 'A');
		//if (*menuitem >= 3)
		//	*menuitem = 3;
		submenu_modusx(cha_amp, chb_amp, cha_mode, chb_mode, menuitem, 'A');
	}


	//cha voltdiv menu
	if (*menustate == 6){
		submenu_voltdivx(cha_amp, chb_amp, cha_mode, chb_mode, 'A', ch_amp_werte);
	}


	//chb modus menu
	if (*menustate == 7){
		switch (*chb_mode){ 
			case ('A'): 
				*menuitem = 1;
				break;
			case ('D'): 
				*menuitem = 2;
				break;
			case ('G'): 
				*menuitem = 3;
				break;
			default: 
				*menuitem = 0;
				break;
		}
		set_mikro(*chb_amp, chb_mode, 'B');
		//if (*menuitem >= 3)
		//	*menuitem = 3;
		submenu_modusx(cha_amp, chb_amp, cha_mode, chb_mode, menuitem, 'B');
	}


	//chb voltdiv menu
	if (*menustate == 8){
		submenu_voltdivx(cha_amp, chb_amp, cha_mode, chb_mode, 'B', ch_amp_werte);
	}



}