@echo off 

REM # -Wa-l : Assembler Listing File


REM # -Wl-m : Linker Map File
REM # -Wl-gvar=addr : Bind var to addr
REM # -Wl-j : symbol file for the no$gmb 

REM # -Wl-ytx : 8 fr ROM + RAM
REM # -Wl-yox : 0 fr ext.ROM 32k (default)
REM # -Wl-yax : 1 fr ext.RAM 8k - anzahl der RAM-Bnke!


REM # Linkeroptionen: 
REM # -Wl-i fr Intel Hex as file[IHX], 
REM # -Wl-s Motorola S19 as file[S19]
REM # -Wl-z Gameboy image as file[GB]


REM # GB-Files zum GB File linken: 
REM # ..\..\gbdk\bin\lcc -Wl-j -Wl-ya1 -Wl-yt8 -Wl-i -o SLOT\gbdso.gb gbdso.c  
REM # ..\..\gbdk\bin\lcc -Wl-j -Wl-ya1 -Wl-yt8 -Wl-s -o SLOT\gbdso.gb gbdso.c 
 
@echo on


REM # Binary File:
..\..\gbdk\bin\lcc -Wl-j -Wl-ya1 -Wl-yt8 -Wl-z -o SLOT\gbdso.gb gbdso.c 



REM # direkt starten:
No$gmb.exe SLOT\gbdso.gb